/*
 *  splash.cc
 *
 *  Copyright (C) 2004 Christoph Dwertmann
 *
 *  Freebooters is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Freebooters is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Freebooters; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "splash.h"
#include "tools.h"

using namespace std;

Splash::Splash()
{
   Tools t;
   animation = t.load_img(t.sprites_path("splashani.png"));
   SDL_SetColorKey (animation,SDL_SRCCOLORKEY,SDL_MapRGB(animation->format,255,0,255));

   dstrect.h=48;
   dstrect.w=48;
   srcrect.h=48;
   srcrect.w=48;
   srcrect.y=0;
}

void Splash::addSplash(int x, int y)
{
   Tools t;
   splash_sound= t.load_wav("splash.wav");

   t.play_sound(splash_sound);

   asplash neu;
   if ((x-24)<0) {
      neu.x=0;
   } else {
      neu.x=x-24;
   }
   
   if ((y-24)<0) {
      neu.y=0;
   } else {
      neu.y=y-24;
   }
   neu.frame=0;
   splashes.push_back(neu);  
}

void Splash::drawSplashes(SDL_Surface* screen){
  for (vector<asplash>::iterator i =splashes.begin(); i != splashes.end (); i++){
    if (i->frame>32) {
      splashes.erase(i);
      i--;
      break;
    }
    srcrect.x=i->frame*48;
    dstrect.x=i->x;
    dstrect.y=i->y;
    SDL_BlitSurface(animation,&srcrect,screen,&dstrect);
    i->frame++;
  }
  
}

void Splash::clear(){
  splashes.clear();
}

int Splash::getSize(){
  return splashes.size();
}
