#ifndef SPRITE_H
#define SPRITE_H

#include <SDL.h>
#include <string>
#include <vector>

class Sprite
{
public:
   Sprite();
   Sprite(const Sprite& other);
   Sprite(SDL_Surface* image_, int x, int y, int w = 0, int h = 0);
   Sprite(std::string filename, int x, int y, int w = 0, int h = 0);
   Sprite(std::vector<std::vector<std::string> > filename, int x, int y, int w=0, int h=0, int a=0, int m=4, int r=-1, int g=-1, int b=-1,int tr=240,int tg=0,int tb=0);
   virtual ~Sprite();
   
   virtual void move(int diff_x, int diff_y);
   virtual void move_to(int x, int y);
   virtual void rotate(int a); 
   virtual void rotate_to(int a); 
   virtual void rotate_baum(int m); 
   virtual void draw(SDL_Surface* target);
   virtual void unload();
   virtual SDL_Surface* get_surface();

   void setcolor(int,int,int);

   virtual const SDL_Rect& get_rect() const;

protected:
   SDL_Surface* image;
   SDL_Rect rect;
   std::vector<std::vector<SDL_Surface*> > views;
   int angle;
   int baumpos;
   int currentview;
};

#endif // SPRITE_H





